/**
    \file 
        TestCullingApplication.cpp
    \brief
        Tests the occlusion culling algorithm
*/

#include "Ogre.h"
#include "TestCullingApplication.h"

#define WIN32_LEAN_AND_MEAN
#include "windows.h"


void TestCullingApplication::createScene(void)
{
     // Create a skybox
     mSceneMgr->setSkyBox(true, "Examples/SpaceSkyBox");
	 mShip = mSceneMgr->createEntity("razor", "razor.mesh");
	 mShipNode = mSceneMgr->getRootSceneNode()->createChildSceneNode();
	 mShipNode->attachObject(mShip);

	 mSceneMgr->setAmbientLight(ColourValue(0.5, 0.5, 0.5));
}


INT WINAPI WinMain( HINSTANCE hInst, HINSTANCE, LPSTR strCmdLine, INT )
{
    // Create application object
    TestCullingApplication app;

	try {
        app.go();
    } catch( Ogre::Exception& e ) {
        MessageBox( NULL, e.getFullDescription().c_str(), "An exception has occured!", MB_OK | MB_ICONERROR | MB_TASKMODAL);
    }	

    return 0;
}


